package com.bonus.material.scrap.mapper;

import java.util.List;

import com.bonus.material.ma.domain.Type;
import com.bonus.material.repair.domain.RepairAuditDetails;
import com.bonus.material.repair.domain.RepairRecord;
import com.bonus.material.scrap.domain.ScrapApplyDetails;
import com.bonus.material.scrap.domain.vo.ScrapDetailsListVo;
import com.bonus.material.scrap.domain.vo.ScrapTaskListVo;
import com.bonus.material.scrap.domain.vo.ScrapTotalListVo;
import org.apache.ibatis.annotations.Param;

/**
 * 报废任务详细Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface ScrapApplyDetailsMapper {
    /**
     * 查询报废任务详细
     * 
     * @param id 报废任务详细主键
     * @return 报废任务详细
     */
    public ScrapApplyDetails selectScrapApplyDetailsById(Long id);

    /**
     * 根据任务id查询报废详情
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapApplyDetails> selectRepairQuestListByTaskId(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废任务详细列表
     * 
     * @param scrapApplyDetails 报废任务详细
     * @return 报废任务详细集合
     */
    List<ScrapTaskListVo> selectScrapApplyDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 新增报废任务详细
     * 
     * @param scrapApplyDetails 报废任务详细
     * @return 结果
     */
    public int insertScrapApplyDetails(ScrapApplyDetails scrapApplyDetails);

    /**
     * 修改报废任务详细
     * 
     * @param scrapApplyDetails 报废任务详细
     * @return 结果
     */
    public int updateScrapApplyDetails(ScrapApplyDetails scrapApplyDetails);

    /**
     * 删除报废任务详细
     * 
     * @param id 报废任务详细主键
     * @return 结果
     */
    public int deleteScrapApplyDetailsById(Long id);

    /**
     * 批量删除报废任务详细
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteScrapApplyDetailsByIds(Long[] ids);

    RepairAuditDetails getByRepairId(String s);

    List<RepairRecord> getGyoupRepairRecord(RepairAuditDetails byRepairId);

    /**
     * 报废任务审核
     * @param applyDetails
     * @return
     */
    int updateStatus(ScrapApplyDetails applyDetails);

    /**
     * 根据任务id查询上级id
     * @param parentId
     * @return
     */
    Long selectBackIdByTaskId(Long parentId);

    /**
     * 修改物资状态
     * @param applyDetails
     * @return
     */
    int updateMaStatus(ScrapApplyDetails applyDetails);

    /**
     * 新增退料
     * @param applyDetails
     * @return
     */
    int insertRad(ScrapApplyDetails applyDetails);

    /**
     * 查询报废台账任务列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapTotalListVo> selectTotalScrapApplyDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 根据任务id查询报废详情
     * @param dto
     * @return
     */
    List<ScrapApplyDetails> selectScrapByTaskId(RepairAuditDetails dto);

    /**
     * 批量根据任务id数组查询报废详情
     */
    List<ScrapApplyDetails> selectScrapByTaskIdList(@Param("list") List<RepairAuditDetails> list);

    /**
     * 台账审核
     * @param scrapApplyDetails
     * @return
     */
    int ledgerApprove(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询盘点报废任务列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapTaskListVo> selectInventoryList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 根据年份和月份查询最大任务编号
     * @param year
     * @param month
     * @return
     */
    int getMonthMaxOrderByDate(@Param("year") String year, @Param("month") String month);

    /**
     * 查询盘点报废任务详情
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapApplyDetails> getDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 删除
     * @param scrapApplyDetails
     * @return
     */
    int delete(ScrapApplyDetails scrapApplyDetails);

    /**
     * 更新库存数量
     * @param applyDetails
     * @return
     */
    int updateStorageNum(ScrapApplyDetails applyDetails);

    /**
     * 盘点报废审核通过
     * @param scrapApplyDetails
     * @return
     */
    int updateTaskStatus(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废台账列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapTotalListVo> getScrapList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询报废台账明细列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapDetailsListVo> getScrapDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 查询库存
     * @param typeId
     * @return
     */
    List<Type> selectMaTypeList(Long typeId);

    /**
     * 添加库存
     * @param details
     * @return
     */
    int updateStorageNumAdd(ScrapApplyDetails details);
}
